Package com.io7m.idstore.server.api

# Record Class IdServerMailTransportSMTP

java.lang.Object
java.lang.Record
com.io7m.idstore.server.api.IdServerMailTransportSMTP

Record Components:
  `host` - The mail host
  `port` - The port

All Implemented Interfaces:
  `IdServerJSONConfigurationElementType`, `IdServerMailTransportConfigurationType`

public record IdServerMailTransportSMTP(String host, int port) extends Record implements IdServerMailTransportConfigurationType
Vanilla SMTP with an insecure STARTTLS upgrade (if supported). This falls back to plaintext when a mail server does not indicate support for STARTTLS. Additionally, even if a TLS session is negotiated, server certificates are not validated in any way. This TransportStrategy only offers protection against passive network eavesdroppers when the mail server indicates support for STARTTLS. Active network attackers can trivially bypass the encryption 1) by tampering with the STARTTLS indicator, 2) by presenting a self-signed certificate, 3) by presenting a certificate issued by an untrusted certificate authority; or 4) by presenting a certificate that was issued by a valid certificate authority to a domain other than the mail server's. For proper mail transport encryption, see SMTPS or SMTP_TLS.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `IdServerMailTransportSMTP(String host, int port)`
  Vanilla SMTP with an insecure STARTTLS upgrade (if supported).

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `String`
  `host()`
  Returns the value of the `host` record component.
  `int`
  `port()`
  Returns the value of the `port` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### IdServerMailTransportSMTP

    public IdServerMailTransportSMTP(String host, int port)
    Vanilla SMTP with an insecure STARTTLS upgrade (if supported). This falls back to plaintext when a mail server does not indicate support for STARTTLS. Additionally, even if a TLS session is negotiated, server certificates are not validated in any way. This TransportStrategy only offers protection against passive network eavesdroppers when the mail server indicates support for STARTTLS. Active network attackers can trivially bypass the encryption 1) by tampering with the STARTTLS indicator, 2) by presenting a self-signed certificate, 3) by presenting a certificate issued by an untrusted certificate authority; or 4) by presenting a certificate that was issued by a valid certificate authority to a domain other than the mail server's. For proper mail transport encryption, see SMTPS or SMTP_TLS.
    Parameters:
      `host` - The mail host
      `port` - The port

- ## Method Details

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. Reference components are compared with `Objects::equals(Object,Object)`; primitive components are compared with '=='.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### host

    public String host()
    Returns the value of the `host` record component.
    Specified by:
      `host` in interface `IdServerMailTransportConfigurationType`
    Returns:
      the value of the `host` record component

  - ### port

    public int port()
    Returns the value of the `port` record component.
    Specified by:
      `port` in interface `IdServerMailTransportConfigurationType`
    Returns:
      the value of the `port` record component